﻿public class Program {

	private static int s_sharedValue = 0;

	private static void Main(string[] args) {
		s_sharedValue = 1;

		int localValue = 2;
		Func<int, int> f = x => {
			s_sharedValue = 3;
			localValue = 4;
			return x + 1;
		};

		int result = f(5);
		Console.WriteLine($"{s_sharedValue} {localValue} {result}");
		s_sharedValue = 6;
		localValue = 7;
		Console.WriteLine($"{s_sharedValue} {localValue}");

		// In the lambda expression above, there are:
		// + 2 free variables:
		//		s_sharedValue
		//		localValue
		// + 1 bound variable:
		//		x
		// When creating the lambda closure:
		// + localValue is bound to localValue variable captured "by move"
		// + s_sharedValue is just bound to the s_sharedValue static (globally accessible) variable (i.e. it is not capture it)
	}
}
