﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

namespace SimpleProducerConsumer_WeirdButCorrect {
	class Program {
		static void Main(string[] args) {
			Queue<int> queue = new Queue<int>();

			// Very weird idea - but actually formally works:
			// We are not using the following StringBuilder instance at all, but we use its syncblock as lock for "queue" and as a condition "queue is non-empty".
			StringBuilder randomBuilder = new StringBuilder();

			var producerThread = new Thread(() => {
				for (int i = 0; i <= 10; i++) {
					lock (randomBuilder) {
						queue.Enqueue(i);
						Monitor.Pulse(randomBuilder);
					}

					Thread.Sleep(250);
				}
			});

			ThreadStart consumer = () => {
				while (true) {
					int item;

					lock (randomBuilder) {
						while (queue.Count == 0) Monitor.Wait(randomBuilder);
						item = queue.Peek();
						if (item == -1) break;	// Swallow the poison pill

						queue.Dequeue();
					}

					Console.WriteLine(string.Format("{0}: {1}", Thread.CurrentThread.ManagedThreadId, item));
				}

				Console.WriteLine("Consumer ending ...");
			};

			var consumerThread1 = new Thread(consumer);
			var consumerThread2 = new Thread(consumer);

			consumerThread1.Start();
			consumerThread2.Start();
			producerThread.Start();

			producerThread.Join();
			// Terminate all consumers
			lock (randomBuilder) {
				queue.Enqueue(-1);			// Prescribe a poison pill to all consumers
				Monitor.PulseAll(randomBuilder);
			}

			consumerThread1.Join();
			consumerThread2.Join();
		}
	}

}
