﻿
SynchronizationContext.SetSynchronizationContext(new CustomDummySynchronizationContext());
Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: Main 1A");
var future1a = GetValueAsync(1, 2);
Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: Main 1B");
var future1b = GetValueAsync(3, 4);
Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: Main 1C");
future1a.Wait();
future1b.Wait();
Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: Main 1D");

Console.WriteLine();
Console.WriteLine("Press ENTER to start example 2 ...");
Console.ReadLine();

Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: Main 2A");
var future2 = GetValueAsync_v2(5, 6);
Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: Main 2B");
future2.Wait();
Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: Main 2C");

Console.WriteLine();
Console.WriteLine("Press ENTER to start example 3 ...");
Console.ReadLine();

Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: Main 3A");
var future3 = GetValueAsync_v3(7, 8);
Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: Main 3B");
future3.Wait();
Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: Main 3C");

static async Task<int> GetValueAsync(int a, int b) {
    Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: GetValueAsync step 0");
    await Task.Delay(1000);
    Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: GetValueAsync step 1");
    await Task.Delay(1000);
    Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: GetValueAsync step 2");
    await Task.Delay(1000);
    Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: GetValueAsync step 3");
    return a + b;
}

static async Task<int> GetValueAsync_v2(int a, int b) {
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: GetValueAsync_v2 step 0");
	await Task.Delay(1000).ConfigureAwait(continueOnCapturedContext: false);
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: GetValueAsync_v2 step 1");
	await Task.Delay(1000);
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: GetValueAsync_v2 step 2");
	await Task.Delay(1000);
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: GetValueAsync_v2 step 3");
	return a + b;
}

static async Task<int> GetValueAsync_v3(int a, int b) {
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: GetValueAsync_v3 step 0");
    await Task.Delay(1000);
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: GetValueAsync_v3 step 1");
	await Task.Delay(1000).ConfigureAwait(continueOnCapturedContext: false);
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: GetValueAsync_v3 step 2");
	await Task.Delay(1000);
	Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: GetValueAsync_v3 step 3");
	return a + b;
}

class CustomDummySynchronizationContext : SynchronizationContext {
    public override void Post(SendOrPostCallback d, object? state) {
        SynchronizationContext.SetSynchronizationContext(this);

        string info = $"Thread {Thread.CurrentThread.ManagedThreadId}: POST before call - d.Target.GetHashCode() == {d.Target!.GetHashCode()}";
        if (state is MulticastDelegate md) {
            info += $"  state.Target.GetHashCode() == { md.Target!.GetHashCode()} ";
        }
        Console.WriteLine(info);
        d(state);
        Console.WriteLine($"Thread {Thread.CurrentThread.ManagedThreadId}: POST after call");
    }
}
