﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace WpfAppTaskYield {
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window {
		public MainWindow() {
			InitializeComponent();
		}

		private CancellationTokenSource fastActionCts = null;
		private long fastActionValue = 0;

		private async void fastActionButton_Click(object sender, RoutedEventArgs e) {
			Title = $"{DateTime.Now.ToLongTimeString()}: fastActionButton_Click @ thread {Thread.CurrentThread.ManagedThreadId} called when counter == {fastActionValue}";

			if (fastActionCts == null) {
				fastActionCts = new CancellationTokenSource();
			} else {
				fastActionCts.Cancel();
				fastActionCts = null;
				return;
			}

			var token = fastActionCts.Token;

			while (!token.IsCancellationRequested) {
				fastActionValue++;
				fastResultsTextBlock.Text = $"Thread {Thread.CurrentThread.ManagedThreadId} updated counter to {fastActionValue}";

				await Task.Delay(1);

				// await Task.Yield();
				// Will block WPF rendering and additional Click processing:
				// Task.Yield documentation: The synchronization context that is present on a UI thread in most UI environments will often prioritize work posted to the context higher
				//							 than input and rendering work. For this reason, do not rely on await Task.Yield(); to keep a UI responsive.
			}
		}
	}
}
